name: CI

on:
  push:
    branches-ignore:
      - "wip*"
    tags:
      - "v*"
  pull_request:
  release:
    types: [published]
  schedule:
    # Daily at 8:33
    - cron: "33 8 * * *"
  workflow_dispatch:

env:
  PIP_DISABLE_PIP_VERSION_CHECK: "1"
  PIP_NO_PYTHON_VERSION_WARNING: "1"

jobs:
  list:
    runs-on: ubuntu-latest
    outputs:
      noxenvs: ${{ steps.noxenvs-matrix.outputs.noxenvs }}
    steps:
      - uses: actions/checkout@v4
      - name: Set up nox
        uses: wntrblm/nox@2024.03.02
      - id: noxenvs-matrix
        run: |
          echo >>$GITHUB_OUTPUT noxenvs=$(
            nox --list-sessions --json | jq '[.[].session]'
          )

  ci:
    needs: list
    runs-on: ubuntu-latest

    strategy:
      fail-fast: false
      matrix:
        noxenv: ${{ fromJson(needs.list.outputs.noxenvs) }}
        posargs: [""]
        include:
          - noxenv: tests-3.12
            posargs: coverage github

    steps:
      - uses: actions/checkout@v4
        with:
          submodules: "recursive"
      - name: Install dependencies
        run: sudo apt-get update && sudo apt-get install -y libenchant-2-dev
        if: runner.os == 'Linux' && startsWith(matrix.noxenv, 'docs')
      - name: Install dependencies
        run: brew install enchant
        if: runner.os == 'macOS' && startsWith(matrix.noxenv, 'docs')
      - name: Set up Python
        uses: actions/setup-python@v5
        with:
          python-version: |
            3.8
            3.9
            3.10
            3.11
            3.12
            pypy3.10
          allow-prereleases: true
          cache: pip
      - name: Set up uv
        uses: hynek/setup-cached-uv@v1
      - name: Set up nox
        uses: wntrblm/nox@2024.04.15

      - name: Run nox
        run: nox -s "${{ matrix.noxenv }}" -- ${{ matrix.posargs }}

  packaging:
    needs: ci
    runs-on: ubuntu-latest
    environment:
      name: PyPI
      url: https://pypi.org/p/referencing
    permissions:
      contents: write
      id-token: write

    steps:
      - uses: actions/checkout@v4
        with:
          submodules: "recursive"
      - name: Set up Python
        uses: actions/setup-python@v5
        with:
          cache: pip
          python-version: "3.x"
      - name: Install dependencies
        run: python -m pip install build
      - name: Create packages
        run: python -m build .
      - name: Publish to PyPI
        if: github.event_name == 'push' && startsWith(github.event.ref, 'refs/tags')
        uses: pypa/gh-action-pypi-publish@release/v1
      - name: Create a Release
        if: github.event_name == 'push' && startsWith(github.event.ref, 'refs/tags')
        uses: softprops/action-gh-release@v2
        with:
          files: |
            dist/*
          generate_release_notes: true
